*piのモンテカルロシミュレーション

clear
local myobs=100
set obs `myobs'
set seed 12345

gen double x=0
gen double y=0
gen double r=0

tempfile zfile
tempname memhold
postfile `memhold' pis using `zfile'

forvalues i=1(1)1000 {
	quietly{
		replace x=runiform()
		replace y=runiform()
		replace r=sqrt(x^2+y^2)
		su r if r<=1
		local tmp=r(N)
		scalar pi=4*`tmp'/`myobs'
		post `memhold' (pi)
	}	
}

postclose `memhold'
use `zfile',clear
su pis
hist pis

